#include <avr/io.h>
#include <avr/interrupt.h>
#define F_CPU 16000000
#include <util/delay.h>
#include <stdlib.h>
#include <inttypes.h>



#define LAYER1 0x84
#define LAYER2 0x88
#define LAYER3 0x90
#define LAYER4 0xa0
#define LAYER5 0xc0
#define LAYER_PORT PORTD // Folosim Portul D pentru nivele
int cub[5][5];
int lay[5];
 
void initLED()
{

	PORTC = 0x00;
	PORTD = 0xFF;
	PORTD = PORTD ^ (1 << 7);
	PORTA = 0x00;
	PORTB = 0x00;


}
void initTimer()
{

	TCCR1B = 5;

	TCNT1 = 0 ;
	OCR1A = F_CPU/(1024) ;

	TIMSK = 16;

}

ISR(TIMER1_COMPA_vect)
{

	TCNT1=0;
}
/* aprinde etajele in corespondenta cu valorile din lay*/
void select_layer(){
	LAYER_PORT =0x00;
	int k,c=0;
	for(k=0;k<5;k++)
		if(lay[k]==1)
			c++;
	if(c%2 ==1){
		if(lay[0]==1)
		LAYER_PORT ^= ~LAYER1;
		if(lay[1]==1)
		LAYER_PORT ^= ~LAYER2;
		if(lay[2]==1)
		LAYER_PORT ^= ~LAYER3;
		if(lay[3]==1)
		LAYER_PORT ^= ~LAYER4;
		if(lay[4]==1)
		LAYER_PORT ^= ~LAYER5;
	}
	else {
		if(lay[0]==1)
		LAYER_PORT ^= ~LAYER1;
		if(lay[1]==1)
		LAYER_PORT ^= ~LAYER2;
		if(lay[2]==1)
		LAYER_PORT ^= ~LAYER3;
		if(lay[3]==1)
		LAYER_PORT ^= ~LAYER4;
		if(lay[4]==1)
		LAYER_PORT ^= ~LAYER5;
		LAYER_PORT= ~LAYER_PORT;
		LAYER_PORT ^=(1<<PD7);
	}
}
/* aprinde ledurile in functie de valorile din cub */
void sel_col(){
	 PORTC = 0x00;
	 PORTA = 0x00;
	 PORTB = 0x00;
	 select_layer();
	 int x , y;
	 for(x=1;x<6;x++)
		for(y=1;y<6;y++){
		 int k=(x-1)*5+y;
		 if((k<9)&&(k>=1))
			if(cub[x-1][y-1]==1) 
				PORTC = PORTC ^ (1<<(k-1));
		 if(k==9)
			if(cub[x-1][y-1]==1) 
				PORTB = PORTB ^ (1 << 7);
		 if(k==10)
			if(cub[x-1][y-1]==1) 
				PORTB = PORTB ^ (1 << 6);
		 if(k==11)
			if(cub[x-1][y-1]==1) 
				PORTB = PORTB ^ (1 << 5);		
		 if(k==12)
			if(cub[x-1][y-1]==1) 
				PORTD = PORTD ^ (1 << 7);
		
		 if(13<=k&&k<21)
			if(cub[x-1][y-1]==1) 
				PORTA = PORTA ^ (1<<(20-k));
		 if(21<=k&&k<26)
			if(cub[x-1][y-1]==1) 
				PORTB = PORTB ^ (1<<(k-21));
		}
} 



void USARTInit(uint16_t ubrr_value)
{

   //Set Baud rate

   UBRRL = ubrr_value;
   UBRRH = (ubrr_value>>8);


   UCSRC=(1<<URSEL)|(3<<UCSZ0);


   //Enable The receiver and transmitter

   UCSRB=(1<<RXEN)|(1<<TXEN);


}


//This function is used to read the available data
//from USART. This function will wait untill data is
//available.
char USARTReadChar()
{
   //Wait untill a data is available

   while(!(UCSRA & (1<<RXC)))
   {
      //Do nothing
   }

   //Now USART has got data from host
   //and is available is buffer

   return UDR;
}


//This fuction writes the given "data" to
//the USART which then transmit it via TX line
void USARTWriteChar(char data)
{
   //Wait untill the transmitter is ready

   while(!(UCSRA & (1<<UDRE)))
   {
      //Do nothing
   }

   //Now write the data to USART buffer

   UDR=data;
}
/*functie de reset a sel_colricei si vectorului ce reprezinta cubul */
void reset(){
	int k,h;
	for(k=0;k<5;k++){
		lay[k]=0;
		for(h=0;h<5;h++)
			cub[k][h]=0;
		}
}
/* functii de delay */
void delay_ms(uint16_t x){
  uint8_t y, z;
  for ( ; x > 0 ; x--){
    for ( y = 0 ; y < 90 ; y++){
      for ( z = 0 ; z < 6 ; z++){
        asm volatile ("nop");		 
      }
    }
  }
}
// functia de delay exact in ms
void delay_real_ms(int val){
	while(val!=0){
		_delay_ms(1);
		val--;
	}
}
/*efectul de ploaie */
void ploaie(int time){
	int e,g,h;
	g=rand()%5;
	h=rand()%5;
	for(e=5;e>0;e--){
		lay[e]=1;
		cub[g][h]=1;
		sel_col();
		delay_real_ms(time);
		lay[e]=0;
		cub[g][h]=0;
		}
}
/*efectul de explozie */
void eff1(time){
	int e,g,h,m,r,p;
	e=2;
	g=3;
	h=3;
	for(m=0;m<3;m++){
		lay[e-m]=1;
		lay[e+m]=1;
		for(r=g-m;r<g+m+1 ;r++)
			for(p=h-m;p<h+m+1 ;p++)
				cub[r-1][p-1]=1;
		sel_col();
		delay_real_ms(time);
		}
	for(m=2;m>=0;m--){
		lay[e-m]=0;
		lay[e+m]=0;
		for(r=g-m;r<g+m+1;r++){		
				cub[r-1][h-m-1]=0;
				cub[r-1][h+m-1]=0;
				}
		for(p=h-m;p<h+m+1 ;p++)
				{		
				cub[g-m-1][p-1]=0;
				cub[g+m-1][p-1]=0;
				}
		sel_col();
		delay_real_ms(time);
		}
	
	
}
/*efectul de explozie 2 */
void eff2(time){
	int m,r,p;
	reset();
	cub[0][0]=1;
	for(m=0;m<5;m++){
		lay[m]=1;
		for(r=0;r<m+1 ;r++)
			for(p=0;p<m+1 ;p++)
				cub[r][p]=1;
		sel_col();
		delay_real_ms(time);
		}
	for(m=4;m>=0;m--){
		lay[m]=0;
		for(r=m;r>=0;r--){		
				cub[r][m]=0;
				}
		for(p=m;p>=0 ;p--)
				{		
				cub[m][p]=0;
				}
		sel_col();
		delay_real_ms(time);
		}
	
	
}
/*efectul de translatare plan */
void eff3(time){
	int m,r;
	reset();
	for(m=0;m<5;m++)
		for(r=0;r<5 ;r++)
			cub[m][r]=1;
	for(m=0;m<5;m++){
		lay[m]=1;
		sel_col();
		delay_real_ms(time);
		lay[m]=0;
		}
	reset();
	for(m=0;m<5;m++)
		lay[m]=1;
	for(m=0;m<5;m++){
		for(r=0;r<5 ;r++)
			cub[m][r]=1;
		sel_col();
		delay_real_ms(time);
		for(r=0;r<5 ;r++)
			cub[m][r]=0;
		}
	reset();
	for(m=0;m<5;m++)
		lay[m]=1;
	for(m=3;m>=0;m--){
		for(r=0;r<5 ;r++)
			cub[m][r]=1;
		sel_col();
		delay_real_ms(time);
		for(r=0;r<5 ;r++)
			cub[m][r]=0;
		}
	reset();
	for(m=0;m<5;m++)
		for(r=0;r<5 ;r++)
			cub[m][r]=1;
	for(m=4;m>=0;m--){
		lay[m]=1;
		sel_col();
		delay_real_ms(time);
		lay[m]=0;
		}
	
}
/*efectul ce afiseaza  P si M = PM */
void eff4(time){
	int m;
	reset();
	for(m=0;m<5;m++) {	
		cub[0][m]=1;
		cub[m][0]=1;	
		cub[m][2]=1;
		}
	cub[4][1]=1;
	for(m=0;m<5;m++) {
		lay[m]=1;
		sel_col();
		delay_real_ms(time);
		lay[m]=0;		
		}
	delay_real_ms(2*time);
		reset();
	for(m=0;m<5;m++) {	
		cub[0][m]=1;
		cub[4][m]=1;	
		}
	cub[3][1]=1;
	cub[2][2]=1;
	cub[1][1]=1;
	for(m=0;m<5;m++) {
		lay[m]=1;
		sel_col();
		delay_real_ms(time);
		lay[m]=0;		
		}
	delay_real_ms(2*time);


}


int main()
{
	DDRC=0xFF;
	DDRD=0xFF;
	DDRA=0xFF;
	DDRB=0xFF;
	TIMSK = 0;
	sei();


	initLED();
	initTimer();

	while(1){
	int o,e;
	reset();
	for(o=1;o<6;o++){
			eff1(600/o);
			}
	reset();
	for(o=1;o<6;o++){
			eff2(600/o);
			}
	reset();
	for(o=1;o<6;o++)
		for(e=0;e<10;e++)
			ploaie(100/o);
		

	reset();
	for(o=1;o<6;o++){
			eff3(600/o);
			}
	reset();
	for(o=1;o<6;o++){
			eff4(600/o);
			}


	}

	return 0;
}
